program redd;
uses Crt,Turbo3;
 
const Ver='22-MAY-2005';
 
type
  ABC  = (A,B,C);
  Channels=A..B;
  Clocks = (Sol,Sid);
  Files  = (Prim,Sec);
  DatRec = record day,month,year :Byte end;
  TimArr = array[0..2] of Byte;
  BCD3Arr= array[0..2] of Byte;
  BCD4Arr= array[0..3] of Byte;
  Str2   = String[2];
  Str3   = String[3];
  Str11  = String[11];
  Str12  = String[12];
  UnPackedObs = record
    obj    :Byte;
    flt    :Byte;
    dur    :Real;
    dat    :DatRec;
    tim    :Real;
    res    :Real;
    timzon :Byte;
    star,
    ovfl,
    flterr,
    solar,
    cal   :Boolean;
    chan  :Channels;
   end;
  Observable = record
    objectno :Byte;
    filter   :Byte;
    duration :BCD3Arr;
    date     :DatRec;
    time     :TimArr;
    result   :BCD4Arr;
    control  :Byte;
      { 7   - overflow
        6   - filter error
        5   -
        3,4 - time zone
        2   - solar time
        1   - calibration
        0   - channel B    }
    end;
  ShortObs = record obs_tim, obs_res : Real;  end;
  ShortFile = file of ShortObs;
  Stars = (Main,Comp,Stan);
  StarStr = String[20];
  AngleRec = record
   case Integer of
   1: (hrs,min,sec       : Byte;
       dsec              : Integer;);
   2: (deg,arcmin,arcsec : Byte;
       darcsec           : Integer;);
   end;
  StarRec = record
    numb : Byte;
    name       : StarStr;
    rect, decl : AngleRec;
    epoch      : Integer;
    case Integer of
    1: (V, B_V, U_B, V_R, V_I,
        y, b_y, m1, c1, Hbeta  : Integer;);
    2: (RecMag : array[1..10] of Integer;);
    end;
 
const
  CR=#$0D;
  LF=#$0A;
  BELL=#7;
  MaxFiltNo = 15;
 
  Zone       : array[0..3] of String[4] = ('UT','UT+1','UT+2','UT+3');
  FiltName   : array[0..MaxFiltNo] of String[2] =
    ('-','U','B','V','R','I','6','7','8','9','Hn','Hw','u','v','b','y');
  Title : String[52] =
    #13#10'60-cm Mt.SUHORA Telescope Photoelectric PHOTOMETER';
  SkyFileName : array[Channels] of String[8] = ('SKYA.TMP','SKYB.TMP');
 BufSize  = 512;
 RecPerBuf = 64;
 SkyCompBufSize = 200;
 Magconst =-1.08574;
 
var
  Buffer    : array[1..BufSize] of Observable;
  SkyCompBuffer : array[ABC,1..SkyCompBufSize] of ShortObs;
  CurObs,CurBuf,CurVar,ObsNo : Integer;
  Empty,MaxOK,TimSolar : Boolean;
  i,j      : Integer;
  ObsFileName,ResFileName : Str12;
  ObsFile  : file;
  ResFile  : Text;
  SkyCompFile  : array[ABC] of ShortFile;
  ExistFile : array[ABC] of Boolean;
  SkyCompNo,LastSkyCompNo,CurSkyComp  : array[ABC] of Integer;
  LastSkyCompTime  : array[ABC] of Real;
  TimeCorr : array[Boolean] of Real;
  chn : Channels;
  chc : ABC;
  Ubs : UnPackedObs;
  CurFilt,TimZone : Byte;
  ObjNo    : array[Channels] of Byte;
  PointMax : Integer;
  TimeOfFirst,Result,Resmag : Real;
  TStr,DStr : Str11;
  chr,ch  : Char;
  DeadTime : array[A..B] of Real;
  DTNoConvLineNo : LongInt;
 
  XX,YY    : Byte;
  OK       : Boolean;
  StrVar   : String;
  rep      : Integer;
 
procedure ClearKbdBuffer;
var cc:Char;
begin
  while KeyPressed do cc:=ReadKey;
end;
 
procedure EndProg;
var cc:ABC;
begin
 for cc:=A to C do
  if ExistFile[cc] then begin
   Close(SkyCompFile[cc]);
   Erase(SkyCompFile[cc]);
  end;
 Close(ObsFile);
 Close(ResFile);
 Halt;
end;
 
procedure PrintFilters;
var k:Byte;
begin
  Write('FILTER NUMBERS:');
  for k:=0 to MaxFiltNo do Write(k:3);
  Writeln('  (0 - NO FILTER)');
  Write('FILTER NAMES  :');
  for k:=0 to MaxFiltNo do Write(FiltName[k]:3);
  Writeln;
end;
 
procedure DecodeFilter(s:Str2; var n:Byte; var err:Boolean);
var i:-1..MaxFiltNo;
   s1:Str2;
   match :Boolean;
begin
  i:=-1;
  repeat
   i:=i+1;
   Str(i,s1);
   match:=(s=FiltName[i]) or (s=s1);
  until match or (i=MaxFiltNo);
  n:=i;
  err:=not match;
end;
 
procedure GetFilter(var f:Byte);
var st:Str2;
   n :Byte;
  err:Boolean;
begin
  PrintFilters;
  repeat
   Write(LF,'Enter FILTER NUMBER or NAME: ');
   Readln(st);
   DecodeFilter(st,n,err);
  until not err;
  f:=n;
end;
 
procedure GetReal(var x:Real);
var t :Real;
   OK :Boolean;
begin
{$I-}
repeat
 t:=x;
 Readln(t);
 OK:=(IOResult=0);
 if not OK then Write(BELL,'BAD NUMBER FORMAT, REPEAT: ');
until OK;
x:=t;
{$I+}
end;
 
procedure GetInt(var n:Integer);
var t :Real;
begin
 t:=Int(n);
 GetReal(t);
 n:=Round(t);
end;
 
procedure GetByt(var b:Byte);
var i:Integer;
begin
 i:=b;
 GetInt(i);
 b:=i;
end;
 
function BCDToByte(b:Byte):Byte;
  begin
    BCDToByte:=10*((b and $F0) shr 4) + (b and $0F);
  end;
 
function ByteToBCD(b:Byte):Byte;
  begin
    if b>=100
      then ByteToBCD:=$FF
      else ByteToBCD:=(b div 10) shl 4 + (b mod 10);
  end;
 
Function ByteToHex(nr:Byte):Str2;
 const
   hexarr :array[0..15] of Char  = '0123456789ABCDEF';
 begin
    ByteToHex:=hexarr[(nr and $F0) shr 4] + hexarr[nr and $0F];
 end;
 
procedure UnPackTime(tim:TimArr; var h,m,s,ss:Byte);
var
  i,j :Byte;
begin
  i:=tim[0];
  j:=tim[1];
  h:=BCDToByte(i shr 2);
  m:=BCDToByte((i shl 5) and $7F or (j shr 3));
  i:=tim[2];
  s:=BCDToByte((j shl 4) and $7F or (i shr 4));
  ss:=i and $0F;
end;
 
function TimeStr(var t:TimArr):Str11;
var
   h,m,s:Str2;
   i,j,ss:Byte;
begin
  i:=t[0];
  j:=t[1];
  h:=ByteToHex(i shr 2);
  m:=ByteToHex((i shl 5) and $7F or (j shr 3));
  i:=t[2];
  s:=ByteToHex((j shl 4) and $7F or (i shr 4));
  ss:=i and $0F;
  TimeStr:=h+':'+m+':'+s+'.'+Char($30+ss);
end;
 
function SecsToStr(t:Real):Str11;
var
 i : Integer;
 s : String[4];
 st: String[6];
begin
 i:=Trunc(t/3600.0);
 Str(i:2,s);
 st:=s+':';
 t:=t-3600.0*i;
 i:=Trunc(t/60.0);
 Str(i:2,s);
 st:=st+s+':';
 t:=t-60.0*i;
 Str(t:4:1,s);
 SecsToStr:=st+s;
end;
 
function Date(var dat:DatRec):Str11;
var
  sd,sy:String[4];
const mt:array[1..12] of array[1..3] of Char =
('JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP','OCT','NOV','DEC');
begin
with dat do begin
 Str(day:2,sd);
 Str((year+1900),sy);
 Date:=sd+'-'+mt[month]+'-'+sy;
end;
end;
 
function BCD3toReal(var t:BCD3Arr): Real;
var
   i :0..2;
   r :Real;
begin
 r:=0;
 for i:=0 to 2 do r:=100.0*r+BCDToByte(t[i]);
 BCD3toReal:=r;
end;
 
function BCD4toReal(var t:BCD4Arr): Real;
var
   i :0..3;
   r :Real;
begin
 r:=0;
 for i:=0 to 3 do r:=100.0*r+BCDToByte(t[i]);
 BCD4toReal:=r;
end;
 
procedure DeadTimeCorr(dt:Real; var res:Real);
var
  step:Integer;
  cres,tres,dif:Real;
begin
  step:=0;
  tres:=res;
  dif:=0.0;
  repeat
    step:=step+1;
    tres:=tres+dif;
    cres:=tres*exp(-1*tres*dt);
    dif:=Abs(res-cres);
  until ( (dif<=0.01) or (step>=50) );
  if dif<=0.01 then res:=tres
    else begin write(BELL); DTNoConvLineNo:=DTNoConvLineNo+1; end;
end;   { DeadTimeCorr }
 
procedure UnPackObs(var Obs: Observable; var Ubs: UnPackedObs);
var
  h,m,s,ss :Byte;
begin
 with Obs do
  with Ubs do begin
   dur:=BCD3toReal(duration)/1000.0;
   if dur>0.0 then res:=BCD4toReal(result)/dur     { counts per second }
     else res:=0.0;
   solar:=(control and 4)<>0;
   UnPackTime(time,h,m,s,ss);
 
   { !!! use it, if observation time is TIME of START of duration !!! }
   tim:=h*3600.0+m*60.0+(s+ss/10.0)+dur/2.0-TimeCorr[solar];
 
   { !!! use it, if observation time is TIME of END of duration !!! }
   { tim:=h*3600.0+m*60.0+(s+ss/10.0)-dur/2.0-TimeCorr[solar]; }
 
   if tim<TimeOfFirst then tim:=tim+86400.0;
   obj:=objectno;
   flt:=filter and $7F;
   timzon:=(control shr 3) and 3;
   star:=(filter and $80)=0;
   dat:=date;
   ovfl:=(control and $80)<>0;
   flterr:=(control and $40)<>0;
   cal:=(control and 2)<>0;
   chan:=Channels(control and 1);
  end;
end;   { UnPackObs }
 
function Where(o:Integer): Integer;
var
 buf,br: Integer;
begin
 if o<1 then o:=1;
 if o>ObsNo then o:=ObsNo;
 buf:=(o-1) div BufSize;
 if buf<>CurBuf then begin
  Seek(ObsFile,RecPerBuf*buf);
  BlockRead(ObsFile,Buffer,RecPerBuf,br);
  CurBuf:=buf;
 end;
 Where:=(o-1) mod BufSize + 1;
end;   { Where }
 
function WhereSkyComp(ch:ABC; o:Integer): Integer;
var
 i: Integer;
begin
 if o<1 then o:=1;
 if o>SkyCompNo[ch] then o:=SkyCompNo[ch];
 if (o<CurSkyComp[ch]) or (o>=CurSkyComp[ch]+SkyCompBufSize) then begin
  CurSkyComp[ch]:=o;
  if o>1 then CurSkyComp[ch]:=o-1;
  Seek(SkyCompFile[ch],CurSkyComp[ch]-1);
  i:=0;
  while (not EOF(SkyCompFile[ch]) and (i<SkyCompBufSize)) do begin
   i:=i+1;
   Read(SkyCompFile[ch],SkyCompBuffer[ch,i]);
  end;
 end;
 WhereSkyComp:=o-CurSkyComp[ch]+1;
end;   { WhereSkyComp }
 
 
procedure WriteSkyFile(Chn:Channels; objectno,Filt:Byte);
const
  MaxCount=100;
  TolSky = 0.2;
var
  i,j,CurObs,Count  : Integer;
  Time1,Time2,LastDur,Sum : real;
  Group : array[1..MaxCount] of Real;
  Ubs : UnPackedObs;
  FirstGroup : Boolean;
  Short : ShortObs;
 
 procedure CloseGroup;
  var
   j,CountOK : Integer;
   Mean,Sum1 : Real;
  begin
    Mean:=Sum/Count;
    Sum1:=0.0;
    CountOK:=0;
    for j:=1 to Count do
      if Abs((Group[j]-Mean)/Mean) < TolSky then begin
       CountOK:=CountOK+1;
       Sum1:=Sum1+Group[j];
      end;
    if CountOK>0 then begin
     Short.obs_tim:=(Time2+Time1)/2.0;
     Short.obs_res:=Sum1/CountOK;
     Write(SkyCompFile[Chn],Short);
    end;
  end;
 
begin    { WriteSkyFile }
 Rewrite(SkyCompFile[Chn]);
 CurObs:=0;
 Time2:=0.0;
 LastDur:=0.0;
 FirstGroup:=True;
 repeat
  CurObs:=CurObs+1;
  i:=Where(CurObs);
  UnPackObs(Buffer[i],Ubs);
  with Ubs do
   if (chan=Chn) and (obj=objectno) and (flt=Filt) and (not star) and
      (not ovfl) and (not flterr) and (not cal)
    then if (tim-Time2 < 2*LastDur) and (Count < MaxCount)
     then  { next in the GROUP }
      begin
       Time2:=tim;
       LastDur:=dur;
       DeadTimeCorr(DeadTime[Chn],res);
       Sum:=Sum+res;
       Count:=Count+1;
       Group[Count]:=res;
      end
     else  { first in the NEW GROUP }
      begin
       if not FirstGroup then CloseGroup;
       FirstGroup:=False;
       Count:=1;
       Time1:=tim;
       Time2:=tim;
       LastDur:=dur;
       DeadTimeCorr(DeadTime[Chn],res);
       Group[1]:=res;
       Sum:=res;
      end;
  { end of with Ubs ... }
 until CurObs=ObsNo;
 if not FirstGroup then CloseGroup;
 Close(SkyCompFile[Chn]);
end;  { WriteSkyFile }
 
function SkyComp(t:Real; ch:ABC): Real;
var
  i,j  : Integer;
  Slope  : Real;
  Curr,CurrNP  : ShortObs;
 
procedure TimGrFirst;
begin
  i:=LastSkyCompNo[ch]-1;
  repeat
   i:=i+1;
   Curr:=SkyCompBuffer[ch,WhereSkyComp(ch,i)];
  until (t<Curr.obs_tim) or (i=SkyCompNo[ch]);
  CurrNP:=SkyCompBuffer[ch,WhereSkyComp(ch,i-1)];
  Slope:=(CurrNP.obs_res-Curr.obs_res)/(CurrNP.obs_tim-Curr.obs_tim);
  SkyComp:=Slope*(t-Curr.obs_tim)+Curr.obs_res;
  if t>Curr.obs_tim
   then begin
    LastSkyCompTime[ch]:=Curr.obs_tim;
    LastSkyCompNo[ch]:=i;
   end
   else begin
    LastSkyCompTime[ch]:=CurrNP.obs_tim;
    LastSkyCompNo[ch]:=i-1;
   end;
end;   { TimGrFirst }
 
begin   { SkyComp }
if SkyCompNo[ch]=1
 then
  SkyComp:=SkyCompBuffer[ch,WhereSkyComp(ch,1)].obs_res
 else begin
 if t<LastSkyCompTime[ch] then begin
  Curr:=SkyCompBuffer[ch,WhereSkyComp(ch,1)];
  LastSkyCompNo[ch]:=1;
  if t<Curr.obs_tim
   then begin       { ekstrapolacja na lewo od pierwszego }
     CurrNP:=SkyCompBuffer[ch,WhereSkyComp(ch,2)];
     Slope:=(CurrNP.obs_res-Curr.obs_res)/(CurrNP.obs_tim-Curr.obs_tim);
     SkyComp:=Slope*(t-Curr.obs_tim)+Curr.obs_res;
     LastSkyCompTime[ch]:=Curr.obs_tim;
    end
   else         { t >= "SkyComp[1]" }
    TimGrFirst; { od pierwszego }
  end
 else
  TimGrFirst;   { od LastSkyCompNo  }
 end;
end;   { SkyComp }
 
 
procedure WriteCompFile(objectno,Filt:Byte);
const
  TolComp = 0.3;
  TabSize = 30;
  TabOffMax = 29;  { = TabSize-1 }
var
  Tab,TimeTab : array[0..TabOffMax] of Real;
  TabOff  : Byte;
  i,j,CurComp,CurObs,PointNo,Back,LastRead : Integer;
  LastDur,LastTime,Sum : Real;
  Ubs : UnPackedObs;
  First : Boolean;
  Status : (Start,Norm,Ende,Off);
 
function GetBack(b:Integer): Byte;
begin
 b:=TabOff-b;
 if b<0 then b:=b+TabSize;
 GetBack:=b;
end;   { GetBack }
 
procedure GetMean;
var
  Sum1,Mean,Time: Real;
  Short : ShortObs;
  CurSh,PN2,CountOK,j : Integer;
begin
 CurSh:=LastRead-CurComp;
 PN2:=PointNo div 2;
 Mean:=Sum/PointNo;
 Sum1:=0.0;
 CountOK:=0;
 for j:=CurSh-PN2 to CurSh+PN2 do
   if Abs((Tab[GetBack(j)]-Mean)/Mean) < TolComp then begin
    CountOK:=CountOK+1;
    Sum1:=Sum1+Tab[GetBack(j)];
   end;
 if CountOK>0 then begin
  Short.obs_tim:=TimeTab[GetBack(CurSh)];
  Short.obs_res:=Sum1/CountOK;
  Write(SkyCompFile[C],Short);
 end;
end;   { GetMean }
 
function Next: Boolean;
var
  Found : Boolean;
  i : Integer;
begin
 Next:=False;
 Found:=False;
 while (not Found) and (CurObs < ObsNo) do begin
  CurObs:=CurObs+1;
  i:=Where(CurObs);
  UnPackObs(Buffer[i],Ubs);
  with Ubs do begin
   Found:=(chan=B) and (obj=objectno) and (flt=Filt) and (star) and
      (not ovfl) and (not flterr) and (not cal);
   if Found then begin
     TabOff:=(TabOff+1) mod TabSize;
     LastRead:=LastRead+1;
     DeadTimeCorr(DeadTime[B],res);
     Tab[TabOff]:=res-SkyComp(tim,B);
     TimeTab[TabOff]:=tim;
     Next:=First or ((tim-LastTime) < 2*LastDur);
     LastTime:=tim;
     LastDur:=dur;
   end; { if Found ... }
  end;  { with Ubs ... }
 end;  { while (not Found) and ... }
 if (not Found) and (CurObs >= ObsNo) then begin
   TabOff:=(TabOff+1) mod TabSize;
   LastRead:=LastRead+1;
 end;
end;  { Next }
 
begin   { WriteCompFile }
 Rewrite(SkyCompFile[C]);
 CurObs:=0;
 LastDur:=0.0;
 LastRead:=0;
 First:=True;
 TabOff:=TabOffMax;
 if Next then begin
 First:=False;
 repeat  { Groups of COMP Loop }
  PointNo:=1;
  LastRead:=1;
  CurComp:=0;
  Sum:=Tab[TabOff];
  Status:=Start;
  while Status=Start do begin     { Start Loop }
   CurComp:=CurComp+1;
   if PointNo=1
   then GetMean
   else begin
       if Next
       then begin
         Sum:=Sum+Tab[TabOff];
         if Next
         then begin
          Sum:=Sum+Tab[TabOff];
          GetMean;
         end
         else begin
          PointNo:=PointNo-2;
          Sum:=Sum-Tab[GetBack(PointNo+1)];
          GetMean;
          if PointNo=1
           then Status:=Off
           else Status:=Ende;
         end;
       end
       else if PointNo=3
          then Status:=Off
          else begin
           CurComp:=CurComp-1;
           PointNo:=PointNo-2;
           Status:=Ende;
          end; { if OUTER Next }
   end; { if Point }
   if Status=Start then
    if PointNo=PointMax
     then Status:=Norm
     else PointNo:=PointNo+2;
  end;  { while Start }
  while Status=Norm do begin     { Norm Loop }
    if Next
    then begin
      CurComp:=CurComp+1;
      Sum:=Sum+Tab[TabOff]-Tab[GetBack(PointMax)];
      GetMean;
      end
    else if PointMax=1
      then Status:=Off
      else Status:=Ende;
  end;  { while Norm }
  while Status=Ende do begin     { Ende Loop }
    CurComp:=CurComp+1;
    PointNo:=PointNo-2;
    Back:=PointNo+1;
    Sum:=Sum-Tab[GetBack(Back)]-Tab[GetBack(Back+1)];
    GetMean;
    if PointNo=1 then Status:=Off;
  end;  { while Ende }
 until CurObs=ObsNo;   { end of Groups Loop }
 end;   { if NO COMPS }
 Close(SkyCompFile[C]);
end;    { WriteCompFile }
 
procedure CheckFileName(name : String; var FileName : Str12; ext : Str3);
var point : Byte;
begin
  point:=Pos('.',name);
  if (point>9) then FileName:=Copy(name,1,8)+Copy(name,point,4)
    else if (point=0) then FileName:=Copy(name,1,8)+'.'+ext
           else FileName:=Copy(name,1,(point-1))+Copy(name,point,4);
end;  { CheckFileName }
 
procedure GetFileName(var FileName : Str12; ext : Str3);
var name : String;
begin
  ClearKbdBuffer;
  Readln(name);
  CheckFileName(name,Filename,ext)
end;  { GetFileName }
 
{ MAIN PROGRAM BODY }
 
begin
 ClrScr;
 Writeln('           ',Title);
 Writeln(CR,LF,'                 REDUCING SOFTWARE');
 Writeln(CR,'                Version ',Ver);
 Writeln(LF,CR,'            corrected for DEAD TIME by MD');
 Writeln(CR,'            Copyright AU & MS 1987,1988');
 Writeln(CR,'    (observation time = time of START of duration)',LF);
 
 YY:=WhereY;
 if ParamCount>0 then CheckFileName(ParamStr(1),ObsFileName,'obs')
 else begin
   Write(CR,'Enter  INPUT DATA File Name [.OBS] : ');
   GetFileName(ObsFileName,'obs');
 end;
 GotoXY(1,YY); ClrEol;
 writeln(' INPUT DATA File : ',ObsFileName);
 
 Assign(ObsFile,ObsFileName);
 Reset(ObsFile);
 
 YY:=WhereY;
 if ParamCount>1 then CheckFileName(ParamStr(2),ResFileName,'red')
 else begin
   Write(CR,'Enter OUTPUT DATA File Name [.RED] : ');
   GetFileName(ResFileName,'red');
 end;
  while ResFileName=ObsFileName do begin
    GotoXY(1,YY); ClrEol;
    writeln('OUTPUT DATA File : ',ResFileName);
    writeln(BELL,
        'Your INPUT DATA File and OUTPUT DATA File have the same names !!!');
    writeln('Press any key ... ');
    ClearKbdBuffer;
    ch:=ReadKey;
    GotoXY(1,YY+2); ClrEol;
    GotoXY(1,YY+1); ClrEol;
    write('Enter another OUTPUT DATA File Name [.RED] : ');
    GetFileName(ResFileName,'red');
    GotoXY(1,YY+1); ClrEol;
  end;  { while ResFileName ... }
  GotoXY(1,YY); ClrEol;
  writeln('OUTPUT DATA File : ',ResFileName);
 
 Assign(ResFile,ResFileName);
 Rewrite(ResFile);
 
 for chc:=A to C do ExistFile[chc]:=False;
 
 Write(CR,LF,'Enter SOLAR TIME CORRECTION in SECONDS',CR,LF,
             '(CLOCK Time - TRUE Time)  [0] : ');
 repeat
   XX:=WhereX;
   YY:=WhereY;
   ClearKbdBuffer;
   Readln(StrVar);
   if StrVar='' then begin TimeCorr[True]:=0.0; OK:=True; end
   else begin
     Val(StrVar,TimeCorr[True],rep);
     if rep<>0 then begin
       OK:=False;
       Write(CR,LF,BELL,
            'BAD NUMBER FORMAT !!!  ==>  REPEAT !    Press any key ... ');
       ClearKbdBuffer;
       ch:=ReadKey;
       GotoXY(1,WhereY); ClrEol;
       GotoXY(XX,YY); ClrEol;
     end else OK:=True;
   end;
 until OK;
 
 Writeln(CR,LF,'Enter DEAD TIME Values in SECONDS :');
 Write(CR,'      - for Channel A  [7e-8] : ');
 repeat
   XX:=WhereX;
   YY:=WhereY;
   ClearKbdBuffer;
   Readln(StrVar);
   if StrVar='' then begin DeadTime[A]:=7e-8; OK:=True; end
   else begin
     Val(StrVar,DeadTime[A],rep);
     if rep<>0 then begin
       OK:=False;
       Write(CR,LF,BELL,
            'BAD NUMBER FORMAT !!!  ==>  REPEAT !    Press any key ... ');
       ClearKbdBuffer;
       ch:=ReadKey;
       GotoXY(1,WhereY); ClrEol;
       GotoXY(XX,YY); ClrEol;
     end else OK:=True;
   end;
 until OK;
 Write(CR,'      - for Channel B  [7e-8] : ');
 repeat
   XX:=WhereX;
   YY:=WhereY;
   ClearKbdBuffer;
   Readln(StrVar);
   if StrVar='' then begin DeadTime[B]:=7e-8; OK:=True; end
   else begin
     Val(StrVar,DeadTime[B],rep);
     if rep<>0 then begin
       OK:=False;
       Write(CR,LF,BELL,
            'BAD NUMBER FORMAT !!!  ==>  REPEAT !    Press any key ... ');
       ClearKbdBuffer;
       ch:=ReadKey;
       GotoXY(1,WhereY); ClrEol;
       GotoXY(XX,YY); ClrEol;
     end else OK:=True;
   end;
 until OK;
 
 TimeCorr[False]:=TimeCorr[True]*1.0027379;
 TimeOfFirst:=-1.0;
 ObsNo:=8*FileSize(ObsFile);
 CurBuf:=-1;
 ObsNo:=ObsNo+1;
 UnPackObs(Buffer[Where(1)],Ubs);
 
 with Ubs do begin
   DStr:=Date(dat);
   TimeOfFirst:=tim;
   TimZone:=timzon;
   TimSolar:=solar;
 end;  { with Ubs }
 
 repeat
   ObsNo:=ObsNo-1;
   with Buffer[Where(ObsNo)] do
       Empty:=(duration[0] or duration[1] or duration[2]) = 0;
 until not Empty;
 
 Write(CR,LF,'Main Star No.: ');  GetByt(ObjNo[A]);
 Write('Comp Star No.: ');  GetByt(ObjNo[B]);
 
 repeat
 Write(CR,LF,
     'Enter Odd Point Number for Scintillations Smoothing Procedure [7] : ');
 repeat
   XX:=WhereX;
   YY:=WhereY;
   ClearKbdBuffer;
   Readln(StrVar);
   if StrVar='' then begin PointMax:=7; OK:=True; end
   else begin
     Val(StrVar,PointMax,rep);
     if rep<>0 then begin
       OK:=False;
       Write(CR,LF,BELL,
            'BAD NUMBER FORMAT !!!  ==>  REPEAT !    Press any key ... ');
       ClearKbdBuffer;
       ch:=ReadKey;
       GotoXY(1,WhereY); ClrEol;
       GotoXY(XX,YY); ClrEol;
     end else OK:=True;
   end;
 until OK;
 until ((PointMax mod 2)=1);
 
repeat   { repeat 1 }
  ClrScr;
  DTNoConvLineNo:=0;
  { GotoXY(1,25); }
  { write('BELL ==>  there is NO CONVERGENCE after 50 steps'); }
  GotoXY(1,1);
  GetFilter(CurFilt);
  Write(CR,LF,'Averaging SKY Observations ...');
  for chn:=A to B do begin
    Assign(SkyCompFile[chn],SkyFileName[chn]);
    WriteSkyFile(chn,ObjNo[chn],CurFilt);
    ExistFile[chn]:=True;
    Reset(SkyCompFile[chn]);
    SkyCompNo[chn]:=FileSize(SkyCompFile[chn]);
    CurSkyComp[chn]:=SkyCompNo[chn]+1;  { to force WhereSkyComp to read first }
    LastSkyCompTime[chn]:=200000.;
  end;  { for chn:=A to B }
 
  if (SkyCompNo[A] > 0) and (SkyCompNo[B] > 0) then begin
    Assign(SkyCompFile[C],'COMP.TMP');
    Write(CR,'Averaging COMPARISON STAR Observations ...');
    WriteCompFile(ObjNo[B],CurFilt);
    ExistFile[C]:=True;
    Reset(SkyCompFile[C]);
    SkyCompNo[C]:=FileSize(SkyCompFile[C]);
    if SkyCompNo[C] > 0 then begin
      Write(CR,'Reducing the Data ...'); ClrEol;
      CurSkyComp[C]:=SkyCompNo[C]+1;  { to force WhereSkyComp to read first }
      LastSkyCompTime[C]:=200000.;
      CurObs:=0;
      CurVar:=0;
         repeat     { repeat 2 }
          CurObs:=CurObs+1;
          i:=Where(CurObs);
          UnPackObs(Buffer[i],Ubs);
          with Ubs do
            if (chan=A) and (obj=ObjNo[A]) and (flt=CurFilt) and (star) and
               (not ovfl) and (not flterr) and (not cal)
            then begin
              CurVar:=CurVar+1;
              if CurVar=1 then begin
                Write(ResFile,CR,LF,'DATE: ',DStr,'    TIME STORED: ');
                if TimSolar then Writeln(ResFile,'SOLAR,  ZONE ',Zone[TimZone])
                            else Writeln(ResFile,'SIDEREAL');
                Writeln(ResFile,'MAIN Star No.',ObjNo[A]:4,
                  '    COMPARISON Star No.',ObjNo[B]:4,
                  '    FILTER ',FiltName[CurFilt]:2);
              end;    { if CurVar=1 ... }
              TStr:=SecsToStr(tim);
              DeadTimeCorr(DeadTime[A],res);
              Result:=(res-SkyComp(tim,A))/SkyComp(tim,C);
              Writeln(ResFile,CurVar:5,(tim/3600.0):9:5,Result:11:5);
            end;    { if (chan=A) and ... }
          { end of with Ubs do ... }
         until CurObs=ObsNo;    { repeat 2 }
      Writeln(CurVar:6,' integrations reduced.');
    end  { if CompNo>0 }   { if SkyCompNo[C]>0 ... }
    else { if CompNo=0 }
      Writeln(CR,LF,LF,'There is NO COMPARISON STAR INTEGRATION in Filter ',
              FiltName[CurFilt]);
  end   { if SkyNos > 0 }  { if (SkyCompNo[A]>0) and (SkyCompNo[B]>0) ... }
  else  { if any SkyNo = 0 }
    Writeln(CR,LF,LF,'There is NO SKY INTEGRATION in Filter ',
                      FiltName[CurFilt]);
 
  if DTNoConvLineNo<>0 then begin
    Write(CR,LF,LF,'There was NO CONVERGENCE after 50 steps in ',
                    DTNoConvLineNo,' lines !');
    Write(CR,LF,'in Dead Time Correction Procedure');
  end;
  Write(CR,LF,LF,'Reduce MORE Filters (y/n) ? ');
  Readln(chr);
until UpCase(chr)='N';    { repeat 1 }
 
 EndProg;
end.
